//c_interface.c

#include "doomdef.h"
#include "common.h"
#include "i_system.h"
#include "w_wad.h"
#include "z_zone.h"
#include "i_system.h"
#include "i_windoz.h"
#include "m_random.h"
#include "m_argv.h"
#include "doomstat.h"
#include "p_local.h"
#include "d_main.h"
#include "info.h"

//FUDGE put these somewhere
extern dboolean setsizeneeded;
extern int	screenblocks;


apiout_t	C_API;
HINSTANCE	hDll=NULL;
dboolean	interfacevalid=false;
char		*DllName;
dboolean	AllowGLNodes=false;

void C_InitDAPI(apiin_t *apiin)
{
    apiin->size=sizeof(apiin_t);
    apiin->version=D_API_VERSION;
    apiin->I_Printf=I_Printf;
    apiin->I_Error=I_Error;
    apiin->Z_Malloc=Z_Malloc;
    apiin->Z_Free=Z_Free;
    apiin->Z_ChangeTag2=Z_ChangeTag2;
    apiin->W_CacheLumpNum=W_CacheLumpNum;
    apiin->W_CacheLumpName=W_CacheLumpName;
    apiin->W_CheckNumForName=W_CheckNumForName;
    apiin->W_GetNumForName=W_GetNumForName;
    apiin->W_LumpLength=W_LumpLength;
    apiin->W_ReadLump=W_ReadLump;
    apiin->M_Random=M_Random;
    apiin->P_MobjThinker=P_MobjThinker;
    apiin->D_IncValidCount=D_IncValidCount;
    apiin->NetUpdate=NetUpdate;
    apiin->thinkercap=&thinkercap;
    apiin->gamemode=&gamemode;
    apiin->ptextureheight=&textureheight;
    apiin->ptexturetranslation=&texturetranslation;
    apiin->pflattranslation=&flattranslation;
    apiin->viewwidth=&viewwidth;
    apiin->viewheight=&viewheight;
    apiin->setsizeneeded=&setsizeneeded;
    apiin->modifiedgame=&modifiedgame;
    apiin->pMainWnd=&hMainWnd;
    apiin->pscreenblocks=&screenblocks;
    apiin->pGammaLevel=&GammaLevel;
	apiin->pWindowPos=&WindowPos;
	apiin->pShowGun=&ShowGun;
	apiin->pInBackground=&InBackground;
	apiin->states=states;
}

void C_ProcessCAPI(apiout_t *apiout)
{
	if (InWindow&&!(apiout->info->caps&APICAP_WINDOW))
		InWindow=false;
	if (!(InWindow||(apiout->info->caps&APICAP_FULLSCREEN)))
	{
		if (apiout->info->caps&APICAP_WINDOW)
			InWindow=true;
		else
			I_Error("Neither Windowed or fullscreen mode supported");
	}
	if ((apiout->info->caps&APICAP_POLYBASED)&&!M_CheckParm("-nogfn"))
		AllowGLNodes=true;
}

void C_Init(void)
{
    apiin_t	apiin;
    int		rc;
    int (__stdcall *DoomAPI)(apiin_t *apiin, apiout_t *apiout);
	char	*errstr;

    C_API.size=sizeof(apiout_t);
    C_API.version=C_API_VERSION;
    C_API.FreeDoomAPI=NULL;
    hDll=LoadLibrary(DllName);
    if (!hDll)
		I_Error("Unable to load %s", DllName);
    (void *)DoomAPI=GetProcAddress(hDll, "DoomAPI");
    if (!DoomAPI)
		I_Error("error in %s (DoomAPI not found)", DllName);
    C_InitDAPI(&apiin);
    rc=DoomAPI(&apiin, &C_API);
    if (rc)
	{
		switch (rc)
		{
		case APIERR_NULLPARM:
		case APIERR_NULLPARM2:
		case APIERR_WRONGSIZE:
			errstr="Invalid Parameters";
			break;
		case APIERR_WRONGVERSION:
			errstr="Incorrect Version";
			break;
		default:
			errstr="Unknown Error";
			break;
		}
		I_Error("%s::DoomAPI Failed(%s)", DllName, errstr);
	}
    if ((C_API.size!=sizeof(apiout_t))||(C_API.version!=C_API_VERSION))
		I_Error("%s interface is wrong version", DllName);
    interfacevalid=true;
    C_ProcessCAPI(&C_API);
	I_Printf("C_Init: %s \"%s\"\n", DllName, C_API.info->name);
}

void C_Shutdown(void)
{
    if (interfacevalid&&C_API.FreeDoomAPI)
		C_API.FreeDoomAPI();
	//FUDGE for some reason this crashes...
#if 0
    if (hDll)
		FreeLibrary(hDll);
#endif
    hDll=NULL;
    interfacevalid=false;
}
