#ifndef D3DR_MD2_H
#define D3DR_MD2_H

#include "t_md2.h"
#include <d3d.h>

typedef struct
{
	float	x;
	float	y;
	float	z;
	DWORD	color;
}modelvert_t;

typedef struct
{
	char			name[16];
	modelvert_t		v[1];
}modelframe_t;

typedef struct
{
	int		index;
	float	tu;
	float	tv;
}modeltris_t;

typedef struct
{
	int		width;
	int		height;
	char	*name;
	LPDIRECT3DTEXTURE2	ptex;
}modelskin_t;

typedef struct
{
	int				numframes;
	int				numverts;
	int				numtris;
	modeltris_t		*tris;
	modelskin_t		*skin;
	int				*cmds;
//variable length
	modelframe_t	*frames[1];
}model_t;

typedef struct
{
	byte	id;//0x0A
	byte	ver;//5
	byte	enc;
	byte	bpp;
	short	x0;
	short	y0;
	short	x1;
	short	y1;
	short	hres;
	short	vres;
	byte	colormap[48];
	byte	res1;
	byte	planes;
	short	linelen;
	short	palinfo;
	byte	res2[58];
}pcxheader_t;

void R_ReadMD2ini(char *name);
void R_SafeRead(void *buff, int size, FILE *fh);

#endif
